%% bare_conf.tex
%% V1.3
%% 2007/01/11
%% by Michael Shell
%% See:
%% http://www.michaelshell.org/
%% for current contact information.
%%
%% This is a skeleton file demonstrating the use of IEEEtran.cls
%% (requires IEEEtran.cls version 1.7 or later) with an IEEE conference paper.
%%PushPull:Streaming
%% Support sites:
%% http://www.michaelshell.org/tex/ieeetran/
%% http://www.ctan.org/tex-archive/macros/latex/contrib/IEEEtran/
%% and
%% http://www.ieee.org/

%%*************************************************************************
%% Legal Notice:
%% This code is offered as-is without any warranty either expressed or
%% implied; without even the implied warranty of MERCHANTABILITY or
%% FITNESS FOR A PARTICULAR PURPOSE! 
%% User assumes all risk.
%% In no event shall IEEE or any contributor to this code be liable for
%% any damages or losses, including, but not limited to, incidental,
%% consequential, or any other damages, resulting from the use or misuse
%% of any information contained here.
%%
%% All comments are the opinions of their respective authors and are not
%% necessarily endorsed by the IEEE.
%%
%% This work is distributed under the LaTeX Project Public License (LPPL)
%% ( http://www.latex-project.org/ ) version 1.3, and may be freely used,
%% distributed and modified. A copy of the LPPL, version 1.3, is included
%% in the base LaTeX documentation of all distributions of LaTeX released
%% 2003/12/01 or later.
%% Retain all contribution notices and credits.
%% ** Modified files should be clearly indicated as such, including  **
%% ** renaming them and changing author support contact information. **
%%
%% File list of work: IEEEtran.cls, IEEEtran_HOWTO.pdf, bare_adv.tex,
%%                    bare_conf.tex, bare_jrnl.tex, bare_jrnl_compsoc.tex
%%*************************************************************************

% *** Authors should verify (and, if needed, correct) their LaTeX system  ***
% *** with the testflow diagnostic prior to trusting their LaTeX platform ***
% *** with production work. IEEE's font choices can trigger bugs that do  ***
% *** not appear when using other class files.                            ***
% The testflow support page is at:
% http://www.michaelshell.org/tex/testflow/



% Note that the a4paper option is mainly intended so that authors in
% countries using A4 can easily print to A4 and see how their papers will
% look in print - the typesetting of the document will not typically be
% affected with changes in paper size (but the bottom and side margins will).
% Use the testflow package mentioned above to verify correct handling of
% both paper sizes by the user's LaTeX system.
%
% Also note that the "draftcls" or "draftclsnofoot", not "draft", option
% should be used if it is desired that the figures are to be displayed in
% draft mode.
%
\documentclass[10pt,conference,compsocconf]{IEEEtran}
%\documentclass[10pt]{IEEEtran}
\usepackage{times}

\usepackage{caption} 
\captionsetup{font=footnotesize,justification=centering,labelsep=period}

% Add the compsoc option for Computer Society conferences.
%
% If IEEEtran.cls has not been installed into the LaTeX system files,
% manually specify the path to it like:
% \documentclass[conference]{../sty/IEEEtran}





% Some very useful LaTeX packages include:
% (uncomment the ones you want to load)


% *** MISC UTILITY PACKAGES ***
%
%\usepackage{ifpdf}
% Heiko Oberdiek's ifpdf.sty is very useful if you need conditional
% compilation based on whether the output is pdf or dvi.
% usage:
% \ifpdf
%   % pdf code
% \else
%   % dvi code
% \fi
% The latest version of ifpdf.sty can be obtained from:
% http://www.ctan.org/tex-archive/macros/latex/contrib/oberdiek/
% Also, note that IEEEtran.cls V1.7 and later provides a builtin
% \ifCLASSINFOpdf conditional that works the same way.
% When switching from latex to pdflatex and vice-versa, the compiler may
% have to be run twice to clear warning/error messages.






% *** CITATION PACKAGES ***
%
%\usepackage{cite}
% cite.sty was written by Donald Arseneau
% V1.6 and later of IEEEtran pre-defines the format of the cite.sty package
% \cite{} output to follow that of IEEE. Loading the cite package will
% result in citation numbers being automatically sorted and properly
% "compressed/ranged". e.g., [1], [9], [2], [7], [5], [6] without using
% cite.sty will become [1], [2], [5]--[7], [9] using cite.sty. cite.sty's
% \cite will automatically add leading space, if needed. Use cite.sty's
% noadjust option (cite.sty V3.8 and later) if you want to turn this off.
% cite.sty is already installed on most LaTeX systems. Be sure and use
% version 4.0 (2003-05-27) and later if using hyperref.sty. cite.sty does
% not currently provide for hyperlinked citations.
% The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/cite/
% The documentation is contained in the cite.sty file itself.






% *** GRAPHICS RELATED PACKAGES ***
%
\ifCLASSINFOpdf
  \usepackage[pdftex]{graphicx}
  % declare the path(s) where your graphic files are
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  \DeclareGraphicsExtensions{.pdf,.jpeg,.png}
\else
  % or other class option (dvipsone, dvipdf, if not using dvips). graphicx
  % will default to the driver specified in the system graphics.cfg if no
  % driver is specified.
  % \usepackage[dvips]{graphicx}
  % declare the path(s) where your graphic files are
  % \graphicspath{{../eps/}}
  % and their extensions so you won't have to specify these with
  % every instance of \includegraphics
  % \DeclareGraphicsExtensions{.eps}
\fi
% graphicx was written by David Carlisle and Sebastian Rahtz. It is
% required if you want graphics, photos, etc. graphicx.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at: 
% http://www.ctan.org/tex-archive/macros/latex/required/graphics/
% Another good source of documentation is "Using Imported Graphics in
% LaTeX2e" by Keith Reckdahl which can be found as epslatex.ps or
% epslatex.pdf at: http://www.ctan.org/tex-archive/info/
%
% latex, and pdflatex in dvi mode, support graphics in encapsulated
% postscript (.eps) format. pdflatex in pdf mode supports graphics
% in .pdf, .jpeg, .png and .mps (metapost) formats. Users should ensure
% that all non-photo figures use a vector format (.eps, .pdf, .mps) and
% not a bitmapped formats (.jpeg, .png). IEEE frowns on bitmapped formats
% which can result in "jaggedy"/blurry rendering of lines and letters as
% well as large increases in file sizes.
%
% You can find documentation about the pdfTeX application at:
% http://www.tug.org/applications/pdftex





% *** MATH PACKAGES ***
%
\usepackage[cmex10]{amsmath}
% A popular package from the American Mathematical Society that provides
% many useful and powerful commands for dealing with mathematics. If using
% it, be sure to load this package with the cmex10 option to ensure that
% only type 1 fonts will utilized at all point sizes. Without this option,
% it is possible that some math symbols, particularly those within
% footnotes, will be rendered in bitmap form which will result in a
% document that can not be IEEE Xplore compliant!
%
% Also, note that the amsmath package sets \interdisplaylinepenalty to 10000
% thus preventing page breaks from occurring within multiline equations. Use:
%\interdisplaylinepenalty=2500
% after loading amsmath to restore such page breaks as IEEEtran.cls normally
% does. amsmath.sty is already installed on most LaTeX systems. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/amslatex/math/





% *** SPECIALIZED LIST PACKAGES ***
%
%\usepackage{algorithmic}
% algorithmic.sty was written by Peter Williams and Rogerio Brito.
% This package provides an algorithmic environment fo describing algorithms.
% You can use the algorithmic environment in-text or within a figure
% environment to provide for a floating algorithm. Do NOT use the algorithm
% floating environment provided by algorithm.sty (by the same authors) or
% algorithm2e.sty (by Christophe Fiorio) as IEEE does not use dedicated
% algorithm float types and packages that provide these will not provide
% correct IEEE style captions. The latest version and documentation of
% algorithmic.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithms/
% There is also a support site at:
% http://algorithms.berlios.de/index.html
% Also of interest may be the (relatively newer and more customizable)
% algorithmicx.sty package by Szasz Janos:
% http://www.ctan.org/tex-archive/macros/latex/contrib/algorithmicx/




% *** ALIGNMENT PACKAGES ***
%
%\usepackage{array}
% Frank Mittelbach's and David Carlisle's array.sty patches and improves
% the standard LaTeX2e array and tabular environments to provide better
% appearance and additional user controls. As the default LaTeX2e table
% generation code is lacking to the point of almost being broken with
% respect to the quality of the end results, all users are strongly
% advised to use an enhanced (at the very least that provided by array.sty)
% set of table tools. array.sty is already installed on most systems. The
% latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/required/tools/


%\usepackage{mdwmath}
%\usepackage{mdwtab}
% Also highly recommended is Mark Wooding's extremely powerful MDW tools,
% especially mdwmath.sty and mdwtab.sty which are used to format equations
% and tables, respectively. The MDWtools set is already installed on most
% LaTeX systems. The lastest version and documentation is available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/mdwtools/


% IEEEtran contains the IEEEeqnarray family of commands that can be used to
% generate multiline equations as well as matrices, tables, etc., of high
% quality.


%\usepackage{eqparbox}
% Also of notable interest is Scott Pakin's eqparbox package for creating
% (automatically sized) equal width boxes - aka "natural width parboxes".
% Available at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/eqparbox/





%\usepackage[tight,footnotesize]{subfigure}
% subfigure.sty was written by Steven Douglas Coc
% *** SUBFIGURE PACKAGES ***hran. This package makes it
% easy to put subfigures in your figures. e.g., "Figure 1a and 1b". For IEEE
% work, it is a good idea to load it with the tight package option to reduce
% the amount of white space around the subfigures. subfigure.sty is already
% installed on most LaTeX systems. The latest version and documentation can
% be obtained at:
% http://www.ctan.org/tex-archive/obsolete/macros/latex/contrib/subfigure/
% subfigure.sty has been superceeded by subfig.sty.



%\usepackage[caption=false]{caption}
%\usepackage[font=footnotesize]{subfig}
% subfig.sty, also written by Steven Douglas Cochran, is the modern
% replacement for subfigure.sty. However, subfig.sty requires and
% automatically loads Axel Sommerfeldt's caption.sty which will override
% IEEEtran.cls handling of captions and this will result in nonIEEE style
% figure/table captions. To prevent this problem, be sure and preload
% caption.sty with its "caption=false" package option. This is will preserve
% IEEEtran.cls handing of captions. Version 1.3 (2005/06/28) and later 
% (recommended due to many improvements over 1.2) of subfig.sty supports
% the caption=false option directly:
%\usepackage[caption=false,font=footnotesize]{subfig}
%
% The latest version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/subfig/
% The latest version and documentation of caption.sty can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/caption/




% *** FLOAT PACKAGES ***
%
%\usepackage{fixltx2e}
% fixltx2e, the successor to the earlier fix2col.sty, was written by
% Frank Mittelbach and David Carlisle. This package corrects a few problems
% in the LaTeX2e kernel, the most notable of which is that in current
% LaTeX2e releases, the ordering of single and double column floats is not
% guaranteed to be preserved. Thus, an unpatched LaTeX2e can allow a
% single column figure to be placed prior to an earlier double column
% figure. The latest version and documentation can be found at:
% http://www.ctan.org/tex-archive/macros/latex/base/



%\usepackage{stfloats}
% stfloats.sty was written by Sigitas Tolusis. This package gives LaTeX2e
% the ability to do double column floats at the bottom of the page as well
% as the top. (e.g., "\begin{figure*}[!b]" is not normally possible in
% LaTeX2e). It also provides a command:
%\fnbelowfloat
% to enable the placement of footnotes below bottom floats (the standard
% LaTeX2e kernel puts them above bottom floats). This is an invasive package
% which rewrites many portions of the LaTeX2e float routines. It may not work
% with other packages that modify the LaTeX2e float routines. The latest
% version and documentation can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/sttools/
% Documentation is contained in the stfloats.sty comments as well as in the
% presfull.pdf file. Do not use the stfloats baselinefloat ability as IEEE
% does not allow \baselineskip to stretch. Authors submitting work to the
% IEEE should note that IEEE rarely uses double column equations and
% that authors should try to avoid such use. Do not be tempted to use the
% cuted.sty or midfloat.sty packages (also by Sigitas Tolusis) as IEEE does
% not format its papers in such ways.



% *** PDF, URL AND HYPERLINK PACKAGES ***
%
%\usepackage{url}
% url.sty was written by Donald Arseneau. It provides better support for
% handling and breaking URLs. url.sty is already installed on most LaTeX
% systems. The latest version can be obtained at:
% http://www.ctan.org/tex-archive/macros/latex/contrib/misc/
% Read the url.sty source comments for usage information. Basically,
% \url{my_url_here}.





% *** Do not adjust lengths that control margins, column widths, etc. ***
% *** Do not use packages that alter fonts (such as pslatex).         ***
% There should be no need to do such things with IEEEtran.cls V1.6 and later.
% (Unless specifically asked to do so by the journal or conference you plan
% to submit to, of course. )

\raggedbottom
%My Custom style to suppress space in text paragraph


% correct bad hyphenation here
\hyphenation{op-tical net-works semi-conduc-tor}

%\parskip 6pt plus 2pt minus 1pt
\parskip 3pt plus 2pt minus 1pt

\pagestyle{empty}
\begin{document}
\pagenumbering{gobble}
%
% paper title
% can use linebreaks \\ within to get better formatting as desired
\title{\textbf{\Large Video Splicing Techniques for P2P Video Streaming \\[-1.5ex]}}

% author names and affiliations
% use a multiple column layout for up to three different
% affiliations
\author{\IEEEauthorblockN{MD Iftakharul Islam and Javed I Khan}
\IEEEauthorblockA{Kent State University\\
Email: {\tt mislam4@kent.edu, javed@cs.kent.edu}}}

% conference papers do not typically use \thanks and this command
% is locked out in conference mode. If really needed, such as for
% the acknowledgment of grants, issue a \IEEEoverridecommandlockouts
% after \documentclass

% for over three affiliations, or if they all won't fit within the width
% of the page, use this alternative format:
% 
%\author{\IEEEauthorblockN{Michael Shell\IEEEauthorrefmark{1},
%Homer Simpson\IEEEauthorrefmark{2},
%James Kirk\IEEEauthorrefmark{3}, 
%Montgomery Scott\IEEEauthorrefmark{3} and
%Eldon Tyrell\IEEEauthorrefmark{4}}
%\IEEEauthorblockA{\IEEEauthorrefmark{1}School of Electrical and Computer Engineering\\
%Georgia Institute of Technology,
%Atlanta, Georgia 30332--0250\\ Email: see http://www.michaelshell.org/contact.html}
%\IEEEauthorblockA{\IEEEauthorrefmark{2}Twentieth Century Fox, Springfield, USA\\
%Email: homer@thesimpsons.com}
%\IEEEauthorblockA{\IEEEauthorrefmark{3}Starfleet Academy, San Francisco, California 96678-2391\\
%Telephone: (800) 555--1212, Fax: (888) 555--1212}
%\IEEEauthorblockA{\IEEEauthorrefmark{4}Tyrell Inc., 123 Replicant Street, Los Angeles, California 90210--4321}}




% use for special paper notices
%\IEEEspecialpapernotice{(Invited Paper)}




% make the title area
\maketitle


\begin{abstract}
%\boldmath
In HTTP live streaming (HLS), a video is spliced into multiple segments of equal duration. The size of the segments has a major impact on the stalls. In adaptive video streaming, clients adapt the bit-rate of the video to minimize the stalls. But it often degrades the video quality. In order to maintain a high video quality, we can adapt the duration of the segments instead of the bit-rate. Thus the splicing technique can have a major impact on a video streaming. 

In this paper, we studied different video splicing techniques for peer-to-peer video streaming. We spliced MPEG-4 video based on different durations and Group of Picture (GOP). We found that the duration based splicing performs better than the GOP based splicing, though the duration based splicing requires much more data to be transferred than the GOP based splicing. In P2P video streaming, peers can leave the swarm anytime. To maximize the availability of a segment, peers often download multiple segments simultaneously. Again, if a peer downloads too many segments at a time, it will increase stalls. In this paper, we proposed a formula to calculate the number of video segments a peer should download simultaneously in order to reduce the stalls. We conducted the experiment on GENI. 

\end{abstract}
% IEEEtran.cls defaults to using nonbold math in the Abstract.
% This preserves the distinction between vectors and scalars. However,
% if the conference you are submitting to favors bold math in the abstract,
% then you can use LaTeX's standard command \boldmath at the very start
% of the abstract to achieve this. Many IEEE journals/conferences frown on
% math in the abstract anyway.

% no keywords

\begin{IEEEkeywords}
P2P Video Streaming; Video Splicing, GENI%
\end{IEEEkeywords}



% For peer review papers, you can put extra information on the cover
% page as needed:
% \ifCLASSOPTIONpeerreview
% \begin{center} \bfseries EDICS Category: 3-BBND \end{center}
% \fi
%
% For peerreview papers, this IEEEtran command inserts a page break and
% creates the second title. It will be ignored for other modes.
\IEEEpeerreviewmaketitle



\section{Introduction}
% no \IEEEPARstart
Video streaming is a major part of Internet traffic. Netflix and Youtube account for more than half of the network traffic in the United States \cite{Sandvine:2015:SandvineWeb}. Cisco also predicted that Internet video will be 79\% of all consumer Internet traffic by 2018. Though most video streaming techniques use a Content Delivery Network (CDN), peer-to-peer architecture is still being used for scalability, fault-tolerance, and anonymity. P2P Internet TVs are very popular in some countries in Asia. PPStream \cite{PPStream:2014:PPStream}, SopCast \cite{SopCast:2014:SopCast}, PPLive \cite{PPLive:2014:PPLive}, etc are some of the most popular P2P video streaming services. But it is difficult to study those large scale P2P systems for their proprietary nature. This paper studies different video splicing techniques for P2P video streaming. We conducted the experiment on GENI. We will demonstrate the video streaming on GENI.

HTTP and TCP are widely being used as a transport mechanism for P2P video streaming services. In HLS \cite{HTTPLiveAdv:2011:HTTPLiveAdvWeb, HTTPLiveAdv:2011:HTTPLiveAdvWeb1}, a video is spliced into multiple segments of equal duration. For example, Netflix and Hulu splice the videos into 4-second and 8-second segments respectively \cite{HLS:stanford}. Their clients determine a bit-rate based on the available bandwidth. As they keep the duration of the segment constant and vary the bit-rates, it will degrade the video quality when the bandwidth becomes low or the network becomes congested (due to competing flows). Instead of varying the bit-rate, we can vary the segment duration. In this way, we can adapt the segment size to avoid stalls without degrading the video quality. This paper studies the effect of splicing techniques on the stalls. We conducted the experiment on a MPEG-4  \cite{MPEG-4:MPEG} video. MPEG-4 is well suited for video streaming and is supported by almost all the major browsers and devices. MPEG-4 is a sequence of GOP (Group of Pictures). A GOP is a sequence of frames. GOP starts with an  I-frame. The rest of the GOP consists of P and B frames. An I-frame is an independent frame, which can be decoded independently. On the other hand, P and B frames are dependent on the I-frame. In this way, a GOP is an independent segment of video that can be played independently. We spliced the video based on GOP. The main benefit of GOP based splicing is there is no overhead. On the other hand, in the duration based splicing, an extra I-frame may  need to be inserted for each segment. As the size of an I-frame is significantly larger than P and B frames, this approach requires much more data to be transferred. Though the duration based splicing has major overhead, we found that it performs better than GOP based splicing for P2P video streaming.

In P2P video streaming, a peer can download multiple segments simultaneously. As peers can leave a swarm anytime, downloading a segment beforehand increases the chance of the availability of a segment. It also increases the bandwidth utilization. Again downloading too many segments may increase stalls as well. The optimum number of segments to download depends on the segment size, available bandwidth, and the duration of the video that the peer already has downloaded. In this paper, we propose an equation to calculate the optimum number of segments such that stalls are not increased.

As the quality of video streaming highly depends on the available bandwidth, we varied bandwidth during the experiment. We conducted our experiment on GENI. GENI \cite{GENI:2014:GENIWebpage} is a United State wide networking test-bed. One can create a virtual network and deploy his applications on the virtual nodes of GENI. This is why GENI is a very suitable platform for experimenting with P2P applications. Our experimental result on GENI shows that the duration based segmentation performs better than the GOP based segmentation.    


The main contributions of this paper are as following:
\begin{itemize}
\item We described the pros and cons of different video splicing techniques for peer-to-peer video streaming (Section 2).
\item We proposed a formula to calculate the number of segments a peer should download simultaneously in order to reduce the stalls. The formula also gives us an idea about the segment size (Section 3 and 4).
\item We conducted the video streaming on GENI. We will demonstrate the video streaming in our presentation. The experimental result gives us an insight into different splicing techniques.
\end{itemize}
			
\section{VIDEO SEGMENTATION}
In this section, we will discuss different video splicing techniques. We will describe the advantages and disadvantages of each of them.

\subsection{GOP Based Segmentation}
Group of Picture (GOP) is a group of I-frame, P-frame, and B-frame. Each GOP can be played independently. The advantage of GOP based splicing is that there is no redundancy among the segments. This makes GOP based splicing an ideal candidate. But we found that the GOPs can be very big, so it can cause stalls. GOPs can be divided into two categories: Open GOP and Closed GOP. In Open GOP, one GOP can be dependent on another. Here we are only dealing with closed GOP where each GOP is completely independent.  


\subsection{Duration Based Segmentation}
Here video is sliced based on a duration. This splicing is frame-accurate. Thus every segment can be played independently. The main disadvantage of this approach is an I-frame is inserted at the beginning of each segment. As the size of an I-frame is significantly larger than P and B frames, if a video is spliced into many very small segments, the total size of the video increases significantly. 

\section{DOWNLOADING POLICY}
In P2P systems, peers usually download multiple segments simultaneously based on the expected bandwidth among the peers. Though video streaming is a sequential process, downloading the segments ahead of time reduces stalls. Besides peers can leave the swarm any time. That is why, it is a good idea to download a segment ahead of time when the segment is available. Again, if a peer downloads too many segments at the same time, it may cause stalling. So we need to find out the optimal number of segments that a peer should download simultaneously, in order to maximize the bandwidth utilization without causing stalling. 

For example, a peer has buffered through segment $N$ and is downloading the next $k$ segments, $N+1, N+2, ..., N+k$ simultaneously. However, if segment $N+1$ has not been fully downloaded by the time currently buffered segments are played ($T$ seconds), a stall will occur. In order to avoid the stall, all the $k$ segments have to be downloaded by $T$ seconds. This is because the peer may download different segments from different peers and all the downloads are sharing some resources, so we cannot determine the order of the downloads of each segment ahead of time.  Let's assume that the size of each segment is $W$ bytes. The available bandwidth among the peers is $B$ B/s.  The peer will calculate the number of segments using the following equation. 
\begin{equation} \label{eq1}
	\begin{split}
 \text{Number of segments to download } \leq \max  \left(\frac{B*T}{W} , 1\right)
	\end{split}
\end{equation}

At the beginning of streaming or if the peer is already stalled or has just finished playing all the buffered video, $T = 0$ second. In those situations, a peer will always download only one segment. Again, if $T$ is very small, $\frac{B*T}{W}$ will be less than one. The peer will download only one segment in that case as well. In the rest of the cases, peer will download at most $\frac{B*T}{W}$ segments. 

To avoid a stall, the peer has to download all the segments in the downloading pool within $T$ seconds. Otherwise the peer may have played the rest of the video in the buffer, but the next segment has not been downloaded. The peer can download $B*T$ bytes in $T$ seconds. As the size of the segment is $W$ bytes, the peer can download $\frac{B*T}{W}$ segments in $T$ seconds. This is the maximum number of segments a peer will download simultaneously. There are many ways to calculate the available bandwidth in the real-world scenario. \cite{Libswift:2014:Libswift} showed a method to calculate the expected bandwidth among the peers in a P2P video streaming. In that paper, they determined the expected bandwidth based on the packet inter-arrival time, round-trip delay, packet-loss, and so on. But in this paper, we simulated the bandwidth on GENI.  


\section{Segment Size}
In our experiment, we found that downloading one large segment is faster than downloading multiple smaller segments. If we increase the size of the segment, the number of segments to download decreases according to \eqref{eq1}. So, keeping the segment large and the number of segments smaller increase the total throughput. But larger segments also increase the load on each peer as they have to upload the segments. So, the size of the segment has to be small enough such that it does not overload the uploading peers. At the same time, the size of the segment should be large enough such that network throughput is not decreased. 

In traditional video streaming, a Content Delivery Networks (CDN) is used for serving content. Many of the P2P video streaming services adopted hybrid architecture where contents are served by peers as well as a CDN. When a video is served by a CDN, peers can download one segment at a time instead of downloading mutiple segments in order to increase the bandwidth utilization. In that case, the maximum size of the segment will be $B*T$ bytes according to \eqref{eq1}. In this way, we can adapt the segment size to increase the network throughput as well as keep the load minimum on each peer without causing a stall.


\section{EXPERIMENTAL SETUP}
We developed the P2P video streaming application in Java. The application itself works as a seeder and a leecher. We conducted the experiment on GENI \cite{GENI:2014:GENIWebpage}. GENI enables us to create a virtual network connecting  virtual hosts on the data centers located in different campus networks across the United States. We used RSpec \cite{RSpec:2014:RSpec} to create the virtual network. RSpec also enabled us to deploy the necessary software packages on every virtual host. These capabilities made GENI a very convenient platform for experimenting with peer-to-peer applications. We conducted the experiment on twenty nodes. A simple RSpec snippet is shown in Figure \ref{Rspec}. Here we showed how we can simulate different network properties among the virtual nodes. The nodes are connected in a star topology using another virtual node. We varied the bandwidth among nodes during the experiment. Here all the nodes are XEN virtual machines running Ubuntu 64-bit operating system. One of the nodes is a seeder here. The seeder slices the video into multiple segments. It slices the video based on GOP or duration according to the configuration. 

\begin{figure}[!t]
	\centering%
	\includegraphics[width=9cm]{RSpec_bandwidth_latency_packetloss}	
	\caption{RSpec snippet of a link}\label{Rspec}
\end{figure}

We developed the application in Java. Developing the application in Java enabled us to be productive as well as to experiment across multiple platforms. We used Xuggler \cite{Xuggler:2014:XugglerWebpage} for manipulating the MPEG-4 videos. Xuggler is a library based on FFmpeg \cite{FFmpeg:2014:FFmpegWebpage}. We also used vlcj \cite{VLCJ:2014:VLCJWebpage} for video playback. vlcj is a library based on LibVLC \cite{LibVLC:2014:LibVLCWebpage}. The application uses Java socket as the transport mechanism. We implemented our own BitTorrent like messaging protocol. We experimented with a 1 Mbps MPEG-4 video. We deployed our application on a InstaGENI rack. The nodes of GENI do not come with an X-window system. In order to play the video on the VMs of GENI, we had to install Unity desktop and VNC server on each node. We automated most part of the experiment using RSpec. Some of the applications require users to accept the terms and conditions during installation. We could not install those application using Rspec. We installed those applications manually on each node. We measured the total number of stalls, total stall duration, and startup time by varying the bandwidth among the peers.   


\section{EXPERIMENTAL RESULTS}

In this section, we present the experimental results of the video slicing techniques. We measured the total number of stalls, total stall duration, and startup time for different types of splicing. We also present the effect of the downloading policy on the stall count. 

\subsection{Comparison between Splicing Techniques}
We measured the total number of stalls for the video for GOP and duration based splicing. Here we varied the bandwidth among the peers and kept the latency 50 milliseconds and the packet loss 5\%. The result is shown in Figure \ref{stalls_bandwidth}. Here we assumed that users are viewing the video sequentially. Research has shown that 95\% of users of a P2P TV watch video sequentially \cite{P2PTV:UserBehaviour}. The video is two minutes long. We ran the application three times for each bandwidth and took the rounded average. Figure \ref{stalls_bandwidth} shows that the GOP based splicing causes more stalls than the duration based splicing. The duration of the GOPs can vary based on the content of the video. For example, if a video contains constantly changing scenery, the duration of the GOP will be very short. If a video contains a stationary scene or a scene where an object is moving slowly, the duration of the GOP can be very long. In GOP based splicing, long and short GOPs result very large and small segments respectively. So, the size of a long GOP can be significantly larger than the size of a short GOP. Very large segments cause stalls in a video streaming because the peer may not have something to play while downloading a large segment. Again very small segments reduce network throughput. In this way, GOP based splicing causes stalls and reduces network throughput. On the other hand, duration based splicing splices the video into equal-duration segments. Here we spliced the video into two, four, and eight seconds segments. Duration based splicing creates segments which are neither too small nor too big. Thus it causes less stalls than GOP based splicing. We found that the 2-second segments cause more stalls than 4-second segments when the available bandwidth among the peers is small. This is because it creates many small TCP connections that create congestion in the network. As we increase the bandwidth, 2-second segments do slightly better and perform similar to 4-second segments. Again 8-second segments results larger segments, thus results more stalls than the smaller segments. 

 \begin{figure}[!t]
 	\centering%
 	\includegraphics[width=9cm]{stalls_bandwidth_embed}	
 	\caption{Total number of stalls for different bandwidths}\label{stalls_bandwidth}
  	\includegraphics[width=9cm]{stallduration_bandwidth_embed}	
  	\caption{Total stall duration for different bandwidths}\label{stallduration_bandwidth} 	
 \end{figure}

Figure \ref{stallduration_bandwidth} compares the total duration of the stalls for different types of splicing. It is clear from the figure that the GOP based splicing results in a longer stall. Again a smaller segment results in a shorter stall. Note that the total number of stalls for the smaller segments can outnumber the total number of stalls for the larger segments, but the total stall duration time is shorter for the shorter segments. 

Figure \ref{startuptime_bandwidth} compares the startup time among different duration based splicings. Startup times of GOP based splicing are different for different videos. Here we compared among 2, 4, and 8-second segments. At the beginning, each peer contacts the seeder and gets different information about the video and the swarm. Here we considered that latency between seeder and peer is 500 milliseconds. Latency among the peers is 50 milliseconds. The figure shows that the large segments can result in a very high startup time in a low bandwidth network. 
  \begin{figure}[!t]
  	\centering%
  	\includegraphics[width=9cm]{startuptime_bandwidth_embed}	
  	\caption{Startup time for different bandwidths}\label{startuptime_bandwidth}
  \end{figure}
 
\subsection{Effect of Downloading Policy}
In this section, we measured the effect of the downloading policy that we described in \eqref{eq1}. We compared the our policy to the fixed size pooling where the application downloads a fixed number of segments at a time. Here the application maintains a downloading pool. We conducted the experiment by varying the size of the downloading pool. Figure \ref{threadpool_stalls} shows that our downloading technique (adaptive pooling) results in less number of stalls than downloading a predefined number of segments at a time. When the bandwidth is small, a large pool size increases the network overload in the peer's network which increases the stalls. Our technique used the information of available bandwidth and the buffered video to limit the number of segments to be downloaded. Again, if users have sufficient bandwidth, the pool size should be large to maximize the bandwidth utilization. 
\begin{figure}[!t]
	\centering%
	\includegraphics[width=9cm]{threadpool_stalls_embed}	
	\caption{Total number of stalls for different pool sizes}\label{threadpool_stalls}
\end{figure}

\section{RELATED WORKS}
BitTorrent \cite{BitTorrent:2014:BitTorrent} is the most popular protocol for transferring files in a P2P system, but it was not designed for sharing interactive media. A video streaming solution has to have a small startup time and minimal stalls. The Internet Engineering Task Force (IETF) defined several P2P video streaming protocols, such as Libswift \cite{libswift:performance}, PPSPP \cite{PPSPP:2012:PPSPP}, etc. These protocols are based on UDP.  In \cite{HLS:stanford}, streaming techniques of Netflix, Hulu, and Vudu have been studied. The researchers studied how the clients adapt the bit-rate based on available bandwidth. Several researches have described the splicing technique of P2P video streaming. A layered encoding technique has been proposed for P2P video streaming where the video is composed of a base layer and enhancement layers \cite{LayerP2P:2009:LayerP2P}. Here the splicing is implemented on the layers. PPLive \cite{PPLive:2014:PPLive} , a popular P2P IPTV, splices the video into a fixed sized block of size 20MB \cite{VSM:VSM, PPLive:Study}. Several researches have been done on video streaming on GENI. \cite{GENICinema:2014:GENICinemaWeb} presented a video streaming solution that exploits multiple paths on GENI. \cite{RINA:2014:RINAWebpage} presented a recursive architecture to program the network traffic for video streaming on GENI. In this paper, we experimented GOP and duration based segmentation for TCP based P2P video streaming. We also proposed a prefetching strategy to minimize the stalls. We conducted the experiment on GENI.


% An example of a floating figure using the graphicx package.
% Note that \label must occur AFTER (or within) \caption.
% For figures, \caption should occur after the \includegraphics.
% Note that IEEEtran v1.7 and later has special internal code that
% is designed to preserve the operation of \label within \caption
% even when the captionsoff option is in effect. However, because
% of issues like this, it may be the safest practice to put all your
% \label just after \caption rather than within \caption{}.
%
% Reminder: the "draftcls" or "draftclsnofoot", not "draft", class
% option should be used if it is desired that the figures are to be
% displayed while in draft mode.
%
%\begin{figure}[!t]
%\centering
%\includegraphics[width=2.5in]{myfigure}
% where an .eps filename suffix will be assumed under latex, 
% and a .pdf suffix will be assumed for pdflatex; or what has been declared
% via \DeclareGraphicsExtensions.
%\caption{Simulation Results}
%\label{fig_sim}
%\end{figure}

% Note that IEEE typically puts floats only at the top, even when this
% results in a large percentage of a column being occupied by floats.


% An example of a double column floating figure using two subfigures.
% (The subfig.sty package must be loaded for this to work.)
% The subfigure \label commands are set within each subfloat command, the
% \label for the overall figure must come after \caption.
% \hfil must be used as a separator to get equal spacing.
% The subfigure.sty package works much the same way, except \subfigure is
% used instead of \subfloat.
%
%\begin{figure*}[!t]
%\centerline{\subfloat[Case I]\includegraphics[width=2.5in]{subfigcase1}%
%\label{fig_first_case}}
%\hfil
%\subfloat[Case II]{\includegraphics[width=2.5in]{subfigcase2}%
%\label{fig_second_case}}}
%\caption{Simulation results}
%\label{fig_sim}
%\end{figure*}
%
% Note that often IEEE papers with subfigures do not employ subfigure
% captions (using the optional argument to \subfloat), but instead will
% reference/describe all of them (a), (b), etc., within the main caption.


% An example of a floating table. Note that, for IEEE style tables, the 
% \caption command should come BEFORE the table. Table text will default to
% \footnotesize as IEEE normally uses this smaller font for tables.
% The \label must come after \caption as always.
%
%\begin{table}[!t]
%% increase table row spacing, adjust to taste
%\renewcommand{\arraystretch}{1.3}
% if using array.sty, it might be a good idea to tweak the value of
% \extrarowheight as needed to properly center the text within the cells
%\caption{An Example of a Table}
%\label{table_example}
%\centering
%% Some packages, such as MDW tools, offer better commands for making tables
%% than the plain LaTeX2e tabular which is used here.
%\begin{tabular}{|c||c|}
%\hline
%One & Two\\
%\hline
%Three & Four\\
%\hline
%\end{tabular}
%\end{table}


% Note that IEEE does not put floats in the very first column - or typically
% anywhere on the first page for that matter. Also, in-text middle ("here")
% positioning is not used. Most IEEE journals/conferences use top floats
% exclusively. Note that, LaTeX2e, unlike IEEE journals/conferences, places
% footnotes above bottom floats. This can be corrected via the \fnbelowfloat
% command of the stfloats package.



\section{Conclusion and Future Work}
This paper measured the effect of splicing on the stalls. It compares the stalls and startup-time for duration and GOP based splicing. We found that duration based splicing performs better than GOP based splicing. We also proposed a prefetching strategy to reduce the stalls. We proposed a formula to calculate the number of segments a peer should download simultaneously. We also determined the segment size in a hybrid P2P system where contents are also served by a CDN. We conducted the experiment on GENI. This study gives us an insight into the splicing techniques for P2P video streaming. This paper showed that splicing techniques have a major impact on stalls and have the potential to be useful to improve the video streaming. 

There are several issues that still need to be addressed. We did not propose an algorithm to determine the optimal segment size. An adaptive splicing technique will be able to increase the performance of P2P video streaming. Here we assumed that the bandwidth among the peers are fixed. But in real-word scenario, available bandwidth changes over time. An experiment should be conducted to measure the effect of splicing on variable bandwidth environment. At the same time, we also should experiment how the splicing works in case of competing flows and high congestion environment. Here we considered that all the peers are generous, but peers are usually very selfish. Our downloading policy also should take that into account. Finally a research should be conducted to compare our splicing technique to the splicing techniques of the state-of-the art P2P video streaming services.

% conference papers do not normally have an appendix


% use section* for acknowledgement
\section*{Acknowledgment}


The authors would like to thank Sarah Edwards of BBN Technologies and Victor Orlikowski of Duke University for their advise and help on tunneling VNC over a SSH channel for playing video on the virtual machines of GENI. The authors also would like to thank the anonymous reviewers for their valuable comments and suggestions to improve the quality of the paper.


% trigger a \newpage just before the given reference
% number - used to balance the columns on the last page
% adjust value as needed - may need to be readjusted if
% the document is modified later
%\IEEEtriggeratref{8}
% The "triggered" command can be changed if desired:
%\IEEEtriggercmd{\enlargethispage{-5in}}

% references section

% can use a bibliography generated by BibTeX as a .bbl file
% BibTeX documentation can be easily obtained at:
% http://www.ctan.org/tex-archive/biblio/bibtex/contrib/doc/
% The IEEEtran BibTeX style support page is at:
% http://www.michaelshell.org/tex/ieeetran/bibtex/
%\bibliographystyle{IEEEtran}
% argument is your BibTeX string definitions and bibliography database(s)
%\bibliography{IEEEabrv,../bib/paper}
%
% <OR> manually copy in the resultant .bbl file
% set second argument of \begin to the number of references
% (used to reserve space for the reference number labels box)
%
% As suggested below, edit bibtemplate_samples.bib to reflect
% your bibliography. See bibtemplate.text for referencing.
%

\bibliographystyle{IEEEtran}
\bibliography{bibtemplate_samples}





% that's all folks
\end{document}


